/************************************************************************/
/**                                                                    **/
/**                   Linux Installation of DISLIN                     **/
/**                                                                    **/
/** Contents: 1.) Introduction                                         **/
/**           2.) Installation of the RPM Distribution                 **/
/**           3.) Installation of the tar.gz Distribution              **/
/**           4.) FTP Sites.                                           **/
/**                                                                    **/
/** Date   : 15.05.2001                                                **/
/** Version: 7.5    / Linux, Imagine F compiler                        **/
/** Author : Helmut Michels, Tel.: +49 5556 979 334                    **/
/**          MPI fuer Aeronomie, Max-Planck-Str. 2,                    **/
/**          D-37191 Katlenburg-Lindau, Germany                        **/
/** Mail:    michels@linmpi.mpg.de                                     **/
/************************************************************************/

1.) Introduction

   DISLIN is a high level and easy to use graphics library for displaying
   data as curves,  bar graphs,  pie charts,  3D-colour plots,  surfaces,
   contours and maps. The software is available for several C, Fortran 77
   and Fortran 90 compilers.
 
   The  Linux version of the graphics software  DISLIN for  the Imagine F
   compiler is distributed  as a compressed  tar file with  the file name
   dislin-n.m.linux.F.tar.gz. The number 'n.m' is the current version  of
   DISLIN. 

   Notes: - The free educational  version of the  PC Linux F compiler can
            be used for this DISLIN version. It is available from
            http://www.imagine1.com/imagine1.    
            
          - An installation of gcc is necessary.  F programs  can be com- 
            piled with the  F compiler  and must be linked with gcc  (see
            the script file f90link for linking programs).
            The DISLIN library is compiled with  gcc 2.7.2  and  contains
            wrapper routines that can be called from F programs.

          - This DISLIN version is free software.

2.) Installation of the RPM Distribution

   The installtion of the RPM distribution of DISLIN for Linux Imagine F
   is very easy. Give the command

                  rpm -i  dislin-7.5.linux.F.rpm

   To uninstall DISLIN for Linux Imagine F give the command:

                  rpm -e  dislin_F 

   Notes:  -  You must be root to install the RPM distribution of DISLIN
              for Linux Imagine F.

           -  The RPM package 'dislin' is required.


3.) Installation of the tar.gz Distribution

a) Uncompress the tar.gz file with the command

                  gzip -d     dislin-7.5.linux.F.tar.gz

b) Restore files from the tar file with the command

                  tar   xvf   dislin-7.5.linux.F.tar    

c) Change to the installation directory of DISLIN

                  cd    dislin-7.5

d) Choose a directory in the file structure where DISLIN should be
   installed and define the environment variable DISLIN with it:

   For example:    DISLIN=$HOME/dislin
                   export DISLIN

e) Run the install program with the command 

                   INSTALL

   This program copies files to $DISLIN and sets protections.

f) To make DISLIN available for general use, write the following com-
   mands to your .profile or to /etc/profile

                    DISLIN=directory                     
                    export DISLIN
                    PATH=${PATH}:${DISLIN}/bin

                    LD_LIBRARY_PATH=$DISLIN:$LD_LIBRARY_PATH
                    export LD_LIBRARY_PATH

   Note: The environment variable DISLIN is not necessary if DISLIN
         is installed in the default directory '/usr/local/dislin'. 

g) Now you can compile, link and run the DISLIN examples in the
   directory $DISLIN/examples/F with the command:

                    f90link -a xxx         

   Note: An alternate linking method can be:

       gcc -o xxx xxx.o -L$DISLIN -ldisf90 $F_LIB/libf95.a -lm

       The -L option can be omitted if links to the DISLIN libraries
       are created in /usr/local/lib:

         ln -s $DISLIN/lib/disf90-7.5.so  libdisf90.so.7
         ln -s libdisf90.so.7             libdisf90.so

         ln -s $DISLIN/lib/disf90-7.5.a   libdisf90.a 

h) You can delete the installation directory 'dislin-7.5'.


3.) Web Sites

   DISLIN is available via ftp anonymous from the following sites:

      ftp://ftp.gwdg.de/pub/grafik/dislin 
      ftp://unix1.mpae.gwdg.de/pub/dislin     

   The DISLIN Home Page is:

      http://www.dislin.de



