!/****************************************************************/
!/**                       DISLIN.F90                           **/
!/**                                                            **/
!/** Module file for DISLIN Fortran 90.                         **/
!/**                                                            **/
!/** Date     : 01.10.2000                                      **/
!/** Routines :      533                                        **/
!/** Version  :  7.4                                            **/
!/****************************************************************/
 
module dislin_mod1

public :: abs3pt, angle , arcell, areaf , autres, ax2grf, ax3len, axclrs
public :: axends, axgit , axis3d, axsbgd, axslen, axsorg, axspos, axsscl
public :: axstyp, bargrp, barpos, bars  , bartyp, barwth, basalf, bezier
public :: bitsi2, bitsi4, box2d , box3d , center, cgmbgd, cgmpic, cgmver
public :: chaang, chaspc, chawth, chnatt, chncrv, chndot, chndsh, chnpie
public :: circle, circsp, clip3d, closfl, clpbor, clpmod, clpwin, clrcyc
public :: clrmod, clswin, color , colran, colray, complx, concrv, congap
public :: conlab, conmat, conmod, conn3d, connpt, conpts, conshd, contur
public :: cross , crvmat, curv3d, curve , curve3, curvmp, curvx3, curvy3
public :: dash  , dashl , dashm , dattim,         disalf, disfin, disini
public :: dot   , dotl  , duplx , dwgbut, dwgfil, dwglis, dwgmsg, dwgtxt
public :: ellips, endgrf, erase , errbar, errdev, errfil, eushft, expzlb
public :: fcha  , field , filbox, filclr, filmod, fixspc, flab3d, flen  
public :: frame , frmess, gapcrv, getalf, getang, getbpp, getclp, getclr
public :: getdig, getdsp, getfil, getgrf, gethgt, getind, getlab, getlen
public :: getlev, getlin, getmat, getmfl, getmix, getor , getpag, getpat
public :: getplv, getpos, getran, getres, getrgb, getscl, getshf, getsp1
public :: getsp2, getsym, gettcl, gettic, gettyp, getuni, getver, getvk 
public :: getvlt, getwid, getwin, getxid, gmxalf, gothic, grace , graf  
public :: graf3 , graf3d, grafmp, grdpol, grffin, grfini, grid  , grid3d
public :: gridmp, gwgbox, gwgbut, gwgfil, gwglis, gwgscl, gwgtxt, height
public :: helve , helves, helvet, histog, hname , hsvrgb, hsymbl, htitle
public :: hwfont, hworig, hwpage, imgfin, imgini, inccrv, incfil, incmrk
public :: intax , intcha, intlen, itmcat, itmcnt, itmstr
public :: barbor, barclr, baropt, basdat, csrmov, csrpt1
public :: csrpts, csruni, incdat, barmod, gwgatt, gwgxid, getscr, getlit 

   interface
      subroutine abs3pt(x,y,z,xp,yp)
        real, intent (in)  :: x,y,z
        real, intent (out) :: xp,yp
      end subroutine abs3pt

      subroutine angle(i)
        integer, intent (in) :: i
      end subroutine angle

      subroutine arcell(nx,ny,na,nb,alpha,beta,theta)
        integer, intent (in) :: nx,ny,na,nb
        real, intent (in)   :: alpha,beta,theta
      end subroutine arcell

      subroutine areaf(ix,iy,n)
        integer, dimension (:), intent (in) :: ix,iy
        integer, intent (in) :: n
      end subroutine areaf

      subroutine autres(i,j)
        integer, intent (in) :: i,j
      end subroutine autres

      subroutine ax2grf()
      end subroutine ax2grf

      subroutine ax3len(i,j,k)
        integer, intent (in) :: i,j,k
      end subroutine ax3len

      subroutine axclrs(n,copt,cax)
        integer, intent(in) :: n
        character (len = *) , intent (in) :: copt, cax
      end subroutine axclrs

      subroutine axends(copt,cax)
        character (len = *) , intent (in) :: copt, cax
      end subroutine axends

      subroutine axgit()
      end subroutine axgit

      subroutine axis3d(x,y,z)
        real, intent (in) :: x,y,z
      end subroutine axis3d

      subroutine axsbgd(n)
        integer, intent (in) :: n
      end subroutine axsbgd

      subroutine axslen(i,j)
        integer, intent (in) :: i,j
      end subroutine axslen

      subroutine axsorg(i,j)
        integer, intent (in) :: i,j
      end subroutine axsorg

      subroutine axspos(i,j)
        integer, intent (in) :: i,j
      end subroutine axspos

      subroutine axsscl(copt,cax)
        character (len = *), intent (in) :: copt,cax
      end subroutine axsscl

      subroutine axstyp(copt)
        character (len = *), intent (in) :: copt
      end subroutine axstyp

      subroutine barbor(iclr)
        integer, intent (in) :: iclr
      end subroutine barbor

      subroutine barclr(ic1,ic2,ic3)
        integer, intent (in) :: ic1,ic2,ic3
      end subroutine barclr

      subroutine bargrp(n,xgap)
        integer, intent (in) :: n
        real, intent (in) :: xgap
      end subroutine bargrp

      subroutine barmod(cmode,copt)
        character (len = *), intent (in) :: cmode,copt
      end subroutine barmod

      subroutine baropt(x1,x2)
        real, intent (in) :: x1,x2
      end subroutine baropt

      subroutine barpos(cpos)
        character (len = *), intent (in) :: cpos
      end subroutine barpos

      subroutine bars(xray,y1ray,y2ray,n)
        real, intent (in out), dimension (:) :: xray,y1ray,y2ray
        integer, intent (in) :: n
      end subroutine bars

      subroutine bartyp(ctyp)
        character (len = *), intent (in) :: ctyp
      end subroutine bartyp

      subroutine barwth(fact)
        real, intent (in) :: fact
      end subroutine barwth

      subroutine basalf(calph)
        character (len = *), intent (in) :: calph
      end subroutine basalf

      subroutine basdat(id,im,iy)
        integer, intent (in) :: id, im, iy
      end subroutine basdat

      subroutine bezier(xray,yray,nray,x,y,n)
        integer, intent (in)  :: nray,n
        real, dimension (:), intent (in)  :: xray, yray
        real, dimension (:), intent (out) :: x, y
      end subroutine bezier

      subroutine bitsi2(nbits,mher,iher,mhin,ihin,lob)
        integer, intent (in) :: nbits,iher,ihin,lob
!        integer (kind=selected_int_kind(4)), intent (in) :: mher
!        integer (kind=selected_int_kind(4)), intent (in out) :: mhin
        integer, intent (in) :: mher
        integer, intent (in out) :: mhin
      end subroutine bitsi2

      subroutine bitsi4(nbits,mher,iher,mhin,ihin,lob)
        integer, intent (in) :: nbits,mher,iher,ihin,lob
        integer, intent (in out) :: mhin
      end subroutine bitsi4

      subroutine box2d()
      end subroutine box2d

      subroutine box3d()
      end subroutine box3d

      subroutine center()
      end subroutine center

      subroutine cgmbgd(xr,xg,xb)
        real, intent (in) :: xr,xg,xb
      end subroutine cgmbgd

      subroutine cgmpic(ct)
        character (len = *), intent (in) :: ct
      end subroutine cgmpic

      subroutine cgmver(n)
        integer, intent (in) :: n
      end subroutine cgmver

      subroutine chaang(x)
        real, intent (in) :: x
      end subroutine chaang

      subroutine chaspc(x)
        real, intent (in) :: x
      end subroutine chaspc

      subroutine chawth(x)
        real, intent (in) :: x
      end subroutine chawth

      subroutine chnatt()
      end subroutine chnatt

      subroutine chncrv(copt)
        character (len = *), intent (in) :: copt
      end subroutine chncrv

      subroutine chndot()
      end subroutine chndot

      subroutine chndsh()
      end subroutine chndsh

      subroutine chnpie(copt)
        character (len = *), intent (in) :: copt
      end subroutine chnpie

      subroutine circle(nx,ny,nr)
        integer, intent (in) :: nx,ny,nr
      end subroutine circle

      subroutine circsp(n)
        integer, intent (in) :: n
      end subroutine circsp

      subroutine clip3d(ctyp)
        character (len = *), intent (in) :: ctyp
      end subroutine clip3d

      subroutine closfl(nlu)
        integer, intent (in) :: nlu
      end subroutine closfl

      subroutine clpbor(copt)
        character (len = *), intent (in) :: copt
      end subroutine clpbor

      subroutine clpmod(cmod)
        character (len = *), intent (in) :: cmod
      end subroutine clpmod

      subroutine clpwin(nx,ny,nw,nh)
        integer, intent (in) :: nx,ny,nw,nh
      end subroutine clpwin

      subroutine clrcyc(i,iclr)
        integer, intent (in) :: i,iclr
      end subroutine clrcyc

      subroutine clrmod(copt)
        character (len = *), intent (in) :: copt
      end subroutine clrmod

      subroutine clswin(id)
        integer, intent (in) :: id
      end subroutine clswin

      subroutine color(copt)
        character (len = *), intent (in) :: copt
      end subroutine color

      subroutine colran(i,j)
        integer, intent (in) :: i,j
      end subroutine colran

      subroutine colray(z,ncol,n)
        real, dimension (:), intent (in) :: z
        integer, dimension (:), intent (out) :: ncol
        integer, intent (in) :: n
      end subroutine colray

      subroutine complx()
      end subroutine complx

      subroutine concrv(x,y,n,zlev)
        real, dimension (:), intent (in) :: x,y
        integer, intent (in) :: n
        real, intent (in) :: zlev
      end subroutine concrv

      subroutine congap(xgap)
        real, intent (in) :: xgap
      end subroutine congap

      subroutine conlab(cstr)
        character (len = *), intent (in) :: cstr
      end subroutine conlab

      subroutine conmat(zmat,n,m,zlev)
        real, dimension (:,:), intent (in) :: zmat
        integer, intent (in) :: n,m
        real, intent (in) :: zlev
      end subroutine conmat

      subroutine conmod (xf1,xf2)
        real, intent (in) :: xf1,xf2
      end subroutine conmod

      subroutine conn3d(x2,y2,z2)
        real, intent (in) :: x2,y2,z2
      end subroutine conn3d

      subroutine connpt(x,y)
        real, intent (in) :: x,y
      end subroutine connpt

      subroutine conpts(x,n,y,m,z,zlev,xpts,ypts,maxpts,nray,maxray,nlins)
        real, dimension (:), intent (in) :: x,y
        real, dimension (:,:), intent (in) :: z
        integer, intent (in) :: n,m,maxpts,maxray
        real, intent (in) :: zlev
        integer, dimension (:), intent (out) :: nray
        integer, intent (out) :: nlins
        real, dimension (:), intent (out) :: xpts,ypts
      end subroutine conpts

      subroutine conshd(xray,n,yray,m,zmat,zlev,nlray)
        real, dimension (:), intent (in) :: xray,yray,zlev
        integer, intent (in) :: n,m,nlray
        real, dimension (:,:), intent (in) :: zmat
      end subroutine conshd

      subroutine contur(x,n,y,m,z,zlev)
        real, dimension (:), intent (in) :: x,y
        integer, intent (in) :: n,m
        real, dimension (:,:), intent (in) :: z
        real, intent (in) :: zlev
      end subroutine contur

      subroutine cross()
      end subroutine cross

      subroutine crvmat(zmat,ixdim,iydim,ixpts,iypts)
        real, dimension (:,:), intent (in) :: zmat
        integer, intent (in) :: ixdim,iydim,ixpts,iypts
      end subroutine crvmat

      subroutine csrpt1(ix,iy)
        integer, intent (out) :: ix,iy
      end subroutine csrpt1

      subroutine csrmov(ixray,iyray,nmax,n,iret)
        integer, dimension (:), intent (out) :: ixray,iyray
        integer, intent (out) :: n, iret
        integer, intent (in) :: nmax
      end subroutine csrmov

      subroutine csrpts(ixray,iyray,nmax,n,iret)
        integer, dimension (:), intent (out) :: ixray,iyray
        integer, intent (out) :: n, iret
        integer, intent (in) :: nmax
      end subroutine csrpts

      subroutine csruni(copt)
        character (len = *), intent (in) :: copt
      end subroutine csruni

      subroutine curv3d(x,y,z,n)
        real, dimension (:), intent (in) :: x,y,z
        integer, intent (in) :: n
      end subroutine curv3d

      subroutine curve(x,y,n)
        real, dimension (:), intent (in) :: x,y
        integer, intent (in) :: n
      end subroutine curve

      subroutine curve3(x,y,z,n)
        real, dimension (:), intent (in) :: x,y,z
        integer, intent (in) :: n
      end subroutine curve3

      subroutine curvmp(x,y,n)
        real, dimension (:), intent (in) :: x,y
        integer, intent (in) :: n
      end subroutine curvmp

      subroutine curvx3(x,y,z,n)
        real, dimension (:), intent (in) :: x,z
        real, intent (in) :: y
        integer, intent (in) :: n
      end subroutine curvx3

      subroutine curvy3(x,y,z,n)
        real, dimension (:), intent (in) :: y,z
        real, intent (in) :: x
        integer, intent (in) :: n
      end subroutine curvy3

      subroutine dash()
      end subroutine dash

      subroutine dashl()
      end subroutine dashl

      subroutine dashm()
      end subroutine dashm

      subroutine dattim(cdat,ctim)
        character (len = *), intent (out) :: cdat,ctim
      end subroutine dattim

      subroutine disalf()
      end subroutine disalf

      subroutine disfin()
      end subroutine disfin

      subroutine disini()
      end subroutine disini

      subroutine dot()
      end subroutine dot

      subroutine dotl()
      end subroutine dotl

      subroutine duplx()
      end subroutine duplx

      subroutine dwgbut(cstr,ival)
        character (len=*), intent (in) :: cstr
        integer, intent (in out) :: ival
      end subroutine dwgbut

      subroutine dwgfil(clab,cstr,cmask)
        character (len=*), intent (in) :: clab,cmask
        character (len=*), intent (in out) :: cstr
      end subroutine dwgfil

      subroutine dwglis(clab,clis,ilis)
        character (len=*), intent(in) :: clab,clis
        integer, intent (in out) :: ilis
      end subroutine dwglis

      subroutine dwgmsg(cstr)
        character (len=*), intent (in) :: cstr
      end subroutine dwgmsg

      subroutine dwgtxt(clab,cstr)
        character (len=*), intent(in) :: clab
        character (len=*), intent(in out) :: cstr
      end subroutine dwgtxt

      subroutine ellips(nx,ny,na,nb)
        integer, intent (in) :: nx,ny,na,nb
      end subroutine ellips

      subroutine endgrf()
      end subroutine endgrf

      subroutine erase()
      end subroutine erase

      subroutine errbar(x,y,err1,err2,n)
        real, dimension (:), intent (in) :: x,y,err1,err2
        integer, intent (in) :: n
      end subroutine errbar

      subroutine errdev(copt)
        character (len = *), intent (in) :: copt
      end subroutine errdev

      subroutine errfil(copt)
        character (len = *), intent (in) :: copt
      end subroutine errfil

      subroutine eushft(calph,csft)
        character (len = *), intent (in) :: calph,csft
      end subroutine eushft

      subroutine expzlb(copt)
        character (len = *), intent (in) :: copt
      end subroutine expzlb

      subroutine fcha(x,ndez,nl,cstr)
        real, intent (in) :: x
        integer, intent (in) :: ndez
        integer, intent (out) :: nl
        character (len = *), intent (out) :: cstr
      end subroutine fcha

      subroutine field(xray,yray,uray,vray,n,ivec)
        real, dimension (:), intent (in) :: xray,yray,uray,vray
        integer, intent (in) :: n,ivec
      end subroutine field

      subroutine filbox(nx,ny,nw,nh)
        integer, intent (in) :: nx,ny,nw,nh
      end subroutine filbox

      subroutine filclr(copt)
        character (len = *), intent (in) :: copt
      end subroutine filclr

      subroutine filmod(cmod)
        character (len = *), intent (in) :: cmod
      end subroutine filmod

      subroutine fixspc(x)
        real, intent (in) :: x
      end subroutine fixspc

      subroutine flab3d()
      end subroutine flab3d

      subroutine flen(x,ndez,nx)
        real, intent (in) :: x
        integer, intent (in) :: ndez
        integer, intent (out) :: nx
      end subroutine flen

      subroutine frame(i)
        integer, intent (in):: i
      end subroutine frame

      subroutine frmess(i)
        integer, intent (in):: i
      end subroutine frmess

      subroutine gapcrv(x)
        real, intent (in) :: x
      end subroutine gapcrv

      subroutine getalf(cstr)
        character (len = *), intent (out) :: cstr
      end subroutine getalf

      subroutine getang(i)
        integer, intent (out) :: i
      end subroutine getang

      subroutine getbpp(i)
        integer, intent (out) :: i
      end subroutine getbpp

      subroutine getclp(nx,ny,nw,nh)
        integer, intent (out) :: nx,ny,nw,nh
      end subroutine getclp

      subroutine getclr(i)
        integer, intent (out) :: i
      end subroutine getclr

      subroutine getdig(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getdig

      subroutine getdsp(cdsp)
        character (len = *), intent (out) :: cdsp
      end subroutine getdsp

      subroutine getfil(cstr)
        character (len = *), intent (out) :: cstr
      end subroutine getfil

      subroutine getgrf(a,e,o,step,copt)
        real, intent (out) :: a,e,o,step
        character (len = *), intent (in) :: copt
      end subroutine getgrf

      subroutine gethgt(i)
        integer, intent (out) :: i
      end subroutine gethgt

      subroutine getind(i,xr,xg,xb)
        integer, intent (in) :: i
        real, intent (out) :: xr,xg,xb
      end subroutine getind

      subroutine getlab(c1,c2,c3)
        character (len = *), intent (out) :: c1,c2,c3
      end subroutine getlab

      subroutine getlen(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getlen

      subroutine getlev(i)
        integer, intent (out) :: i
      end subroutine getlev

      subroutine getlin(i)
        integer, intent (out) :: i
      end subroutine getlin

      subroutine getlit(xp,yp,zp,xn,yn,zn,i)
        integer, intent (in) :: xp,yp,zp,xn,yn,zn
        integer, intent (out) :: i
      end subroutine getlit

      subroutine getmat(x,y,z,n,zmat,nx,ny,zval,imat,wmat)
        real, dimension (:), intent (in) :: x,y,z
        integer, intent (in) :: n,nx,ny
        real, dimension (:,:), intent (out) :: zmat
        real, intent (in) :: zval
        integer, dimension (:,:), intent (in out) :: imat
        real, dimension (:,:), intent (in out) :: wmat
      end subroutine getmat

      subroutine getmfl(cstr)
        character (len = *), intent (out) :: cstr
      end subroutine getmfl

      subroutine getmix(c,cstr)
        character (len = *), intent (out) :: c
        character (len = *), intent (in) :: cstr
      end subroutine getmix

      subroutine getor(i,j)
        integer, intent (out) :: i,j
      end subroutine getor

      subroutine getpag(i,j)
        integer, intent (out) :: i,j
      end subroutine getpag

      subroutine getpat(i)
        integer, intent (out) :: i
      end subroutine getpat

      subroutine getplv(i)
        integer, intent (out) :: i
      end subroutine getplv

      subroutine getpos(i,j)
        integer, intent (out) :: i,j
      end subroutine getpos

      subroutine getran(i,j)
        integer, intent (out) :: i,j
      end subroutine getran

      subroutine getres(i,j)
        integer, intent (out) :: i,j
      end subroutine getres

      subroutine getrgb(xr,xg,xb)
        real, intent (out) :: xr,xg,xb
      end subroutine getrgb

      subroutine getscl(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getscl

      subroutine getscr(i,j)
        integer, intent (out) :: i,j
      end subroutine getscr

      subroutine getshf(cstr,c)
        character (len = *), intent (out) :: c
        character (len = *), intent (in) :: cstr
      end subroutine getshf

      subroutine getsp1(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getsp1

      subroutine getsp2(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getsp2

      subroutine getsym(i,j)
        integer, intent (out) :: i,j
      end subroutine getsym

      subroutine gettcl(i,j)
        integer, intent (out) :: i,j
      end subroutine gettcl

      subroutine gettic(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine gettic

      subroutine gettyp(i)
        integer, intent (out) :: i
      end subroutine gettyp

      subroutine getuni(i)
        integer, intent (out) :: i
      end subroutine getuni

      subroutine getver(xver)
        real, intent (out) :: xver
      end subroutine getver

      subroutine getvk(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getvk

      subroutine getvlt(ctab)
        character (len = *), intent (out) :: ctab
      end subroutine getvlt

      subroutine getwid(i)
        integer, intent (out) :: i
      end subroutine getwid

      subroutine getwin(ix,iy,nw,nh)
        integer, intent (out) :: ix,iy,nw,nh
      end subroutine getwin

      subroutine getxid (ival, copt)
        integer, intent (out) :: ival
        character (len = *), intent (in) :: copt
      end subroutine getxid

      subroutine gmxalf(calph,ca,cb,n)
        character (len = *), intent (in) :: calph
        character (len = *), intent (out) :: ca,cb
        integer, intent (out) :: n
      end subroutine gmxalf

      subroutine gothic()
      end subroutine gothic

      subroutine grace(i)
        integer, intent (in) :: i
      end subroutine grace

      subroutine graf(ax,ex,orx,stepx,ay,ey,ory,stepy)
        real, intent (in) :: ax,ex,orx,stepx,ay,ey,ory,stepy
      end subroutine graf

      subroutine graf3(ax,ex,orx,stepx,ay,ey,ory,stepy,az,ez,orz,stepz)
        real, intent (in) :: ax,ex,orx,stepx,ay,ey,ory,stepy,az,ez,orz,stepz
      end subroutine graf3

      subroutine graf3d(ax,ex,orx,stepx,ay,ey,ory,stepy,az,ez,orz,stepz)
        real, intent (in) :: ax,ex,orx,stepx,ay,ey,ory,stepy,az,ez,orz,stepz
      end subroutine graf3d

      subroutine grafmp(ax,ex,orx,stepx,ay,ey,ory,stepy)
        real, intent (in) :: ax,ex,orx,stepx,ay,ey,ory,stepy
      end subroutine grafmp

      subroutine grdpol(igrd,jgrd)
        integer, intent (in) :: igrd,jgrd
      end subroutine grdpol

      subroutine grffin()
      end subroutine grffin

      subroutine grfini(x1,y1,z1,x2,y2,z2,x3,y3,z3)
        real, intent (in) :: x1,y1,z1,x2,y2,z2,x3,y3,z3
      end subroutine grfini

      subroutine grid(i,j)
        integer, intent (in) :: i,j
      end subroutine grid

      subroutine grid3d(igrid,jgrid,copt)
        integer, intent (in) :: igrid,jgrid
        character (len = *), intent (in) :: copt
      end subroutine grid3d

      subroutine gridmp(i,j)
        integer, intent (in) :: i,j
      end subroutine gridmp

      subroutine gwgatt (id,ival,copt)
        integer, intent (in) :: id
        integer, intent (out) :: ival
        character (len=*), intent (in) :: copt
      end subroutine gwgatt

      subroutine gwgbox(id,ival)
        integer, intent (in) :: id
        integer, intent (out) :: ival
      end subroutine gwgbox

      subroutine gwgbut(id,ival)
        integer, intent (in) :: id
        integer, intent (out) :: ival
      end subroutine gwgbut

      subroutine gwgfil(id,cstr)
        integer, intent (in) :: id
        character (len=*), intent (out) :: cstr
      end subroutine gwgfil

      subroutine gwglis(id,ival)
        integer, intent (in) :: id
        integer, intent (out) :: ival
      end subroutine gwglis

      subroutine gwgscl(id,xval)
        integer, intent (in) :: id
        real, intent (out) :: xval
      end subroutine gwgscl

      subroutine gwgtxt(id,cstr)
        integer, intent (in) :: id
        character (len=*), intent (out) :: cstr
      end subroutine gwgtxt

      subroutine gwgxid(id,ival)
        integer, intent (in) :: id
        integer, intent (out) :: ival
      end subroutine gwgxid

      subroutine height(i)
        integer, intent (in) :: i
      end subroutine height

      subroutine helve()
      end subroutine helve

      subroutine helves()
      end subroutine helves

      subroutine helvet()
      end subroutine helvet

      subroutine histog(xray,n,x,y,m)
        real, dimension (:), intent (in) :: xray
        integer, intent (in) :: n
        real, dimension (:), intent (out) :: x,y
        integer, intent (out) :: m
      end subroutine histog

      subroutine hname(i)
        integer, intent (in) :: i
      end subroutine hname

      subroutine hsvrgb(xh,xs,xv,r,g,b)
        real, intent (in)  :: xh,xs,xv
        real, intent (out) :: r,g,b
      end subroutine hsvrgb

      subroutine hsymbl(i)
        integer, intent (in) :: i
      end subroutine hsymbl

      subroutine htitle(i)
        integer, intent (in) :: i
      end subroutine htitle

      subroutine hwfont()
      end subroutine hwfont

      subroutine hworig(nx,ny)
        integer, intent (in) :: nx,ny
      end subroutine hworig

      subroutine hwpage(nxp,nyp)
        integer, intent (in) :: nxp,nyp
      end subroutine hwpage

      subroutine imgfin()
      end subroutine imgfin

      subroutine imgini()
      end subroutine imgini

      subroutine inccrv(i)
        integer, intent (in) :: i
      end subroutine inccrv

      function incdat(id,im,iy) result (iret)
        integer, intent (in) :: id, im, iy
        integer :: iret
      end function incdat

      subroutine incfil(cstr)
        character (len = *), intent (in) :: cstr
      end subroutine incfil

      subroutine incmrk(i)
        integer, intent (in) :: i
      end subroutine incmrk

      subroutine intax()
      end subroutine intax

      subroutine intcha(num,n,cnum)
        integer, intent (in)  :: num
        integer, intent (out) :: n
        character (len = *), intent (out) :: cnum
      end subroutine intcha

      subroutine intlen(nm,nlaen)
        integer, intent (in)  :: nm
        integer, intent (out) :: nlaen
      end subroutine intlen

      subroutine itmcat(clis,cstr)
        character (len=*), intent (in out) :: clis
        character (len=*), intent (in) :: cstr
      end subroutine itmcat

      function itmcnt(clis) result(iret)
        character (len=*), intent (in) :: clis
        integer :: iret
      end function itmcnt

      subroutine itmstr(clis,nlis,cstr)
        character (len=*), intent (in) :: clis
        character (len=*), intent (out) :: cstr
        integer, intent (in) :: nlis
      end subroutine itmstr
  end interface
end module dislin_mod1
