!/****************************************************************/
!/**                       DISLIN.F90                           **/
!/**                                                            **/
!/** Module file for DISLIN Fortran 90.                         **/
!/**                                                            **/
!/** Date     : 01.10.2000                                      **/
!/** Routines :      533                                        **/
!/** Version  :  7.4                                            **/
!/****************************************************************/
 
module dislin_mod2

public :: labclr, labdig
public :: labdis, labels, labjus, labpos, labtyp, legclr, legend, legini
public :: leglin, legopt, legpat, legpos, legtit, lfttit, lincyc, line  
public :: linesp, lintyp, linwid, lncap , lnjoin, lnmlt , logtic, lsechk
public :: mapbas, maplev, mapmod, mappol, mapref, mapsph, marker, mdfmat
public :: messag, metafl, mixalf, mixleg, moment, mpaepl, mplang, mplclr
public :: mplpos, mplsiz, msgbox, mylab , myline, mypat , mypie , myvlt 
public :: namdis, name  , namjus, neglog, newmix, newpag, nlmess, nlnumb
public :: noarln, nobar , nobgd , nochek, noclip, nofill, nograf, nohide
public :: noline, number, numfmt, numode, nxlegn, nxposn, nylegn, nyposn
public :: nzposn, openfl, opnwin, origin, page  , pagera, pagfll, paghdr
public :: pagmod, patcyc, penwid, pie   , pieexp, piegrf, pielab, pievec
public :: point , polcrv, pos2pt, pos3pt, posifl, projct, psfont, readfl
public :: recfll, rectan, rel3pt, resatt, reset , revscr, rgbhsv, rgtlab
public :: rimage, rlarc , rlarea, rlcirc, rlconn, rlell , rline , rlmess
public :: rlnumb, rlpie , rlpoin, rlrec , rlrnd , rlsec , rlstrt, rlsymb
public :: rlvec , rndrec, rpixel, rpixls, rpxrow, rtiff , rvynam 
public :: sclfac, sclmod, scmplx, scrmod, sector, selwin, sendbf, sendok
public :: serif , setbas, setclr, setexp, setfil, setgrf, setind, setmix
public :: setpag, setres, setrgb, setscl, setvlt, setxid, shdcha, shdcrv
public :: shdeur, shdmap, shdmod, shdpat, shield, shlcir, shldel, shlell
public :: shlind, shlpie, shlpol, shlrct, shlrec, shlres, shlsur, shlvis
public :: simplx, skipfl, smxalf, solid , sortr1, sortr2, spline, splmod
public :: strt3d, strtpt, surclr, surfce,                 surmat, surmsh
public :: surshd, sursze, survis, swapi2, swapi4, swgbox, swgbut  
public :: swgfil, swgfnt, swghlp, swgjus, swglis, swgmix, swgmod, swgmrg
public :: swgoff, swgpop, swgpos, swgscl, swgsiz, swgtit, swgtxt, swgtyp
public :: swgwin, swgwth, symbol, symfil, symrot, tellfl, thkcrv, ticks 
public :: ticlen, ticpos, tiforg, tifwin, timopt, titjus, title , titlin
public :: titpos, trfco1, trfco2, trfco3, trfrel, trfres, trfrot, trfscl
public :: trfshf, triplx, trmlen, txtjus
public :: labmod, nwkday, piebor, pieclr, pieopt, pietyp, qplbar, qplcon
public :: qplot,  qplpie, qplsca, qplsur, qplclr, rpng  , suropt, ticmod
public :: trfdat, swgatt, swgdrw, swgopt, swgspc, sendmb, rbfpng
public :: light, litmod, litopt, litpos, matopt, mshclr, rppm, sphe3d
public :: suriso, texmod, texopt

!public :: surfcp, surfun, swgcb, swgcbk

  interface
    subroutine labclr(iclr,copt)
      integer, intent (in) :: iclr
      character (len = *), intent (in) :: copt
    end subroutine labclr

    subroutine labdig(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine labdig

    subroutine labdis(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine labdis

    subroutine labels(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labels

    subroutine labjus(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labjus

    subroutine labmod(ckey,copt,cax)
      character (len = *), intent (in) :: ckey,copt,cax
    end subroutine labmod

    subroutine labpos(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labpos

    subroutine labtyp(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labtyp

    subroutine legclr()
    end subroutine legclr

    subroutine legend(cbf,ncor)
      character (len = *), intent (in) :: cbf
      integer, intent (in) :: ncor
    end subroutine legend

    subroutine legini(cbf,nlin,nmax)
      character (len = *), intent (in out) :: cbf
      integer, intent (in) :: nlin, nmax
    end subroutine legini

    subroutine leglin(cbf,cstr,n)
      character (len = *), intent (in out) :: cbf
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: n
    end subroutine leglin

    subroutine legopt(x1,x2,x3)
      real, intent (in) :: x1,x2,x3
    end subroutine legopt

    subroutine legpat(ilin,ithk,isym,iclr,ipat,i)
      integer, intent (in) :: ilin,ithk,isym,iclr,ipat,i
    end subroutine legpat

    subroutine legpos(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine legpos

    subroutine legtit(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine legtit

    subroutine lfttit()
    end subroutine lfttit

    subroutine lincyc(i,ilin)
      integer, intent (in) :: i,ilin
    end subroutine lincyc

    subroutine line(nx,ny,nu,nv)
      integer, intent (in) :: nx,ny,nu,nv
    end subroutine line

    subroutine linesp(x)
      real, intent (in) :: x
    end subroutine linesp

    subroutine lintyp(i)
      integer, intent (in) :: i
    end subroutine lintyp

    subroutine linwid(i)
      integer, intent (in) :: i
    end subroutine linwid

    subroutine light(copt)
      character (len = *), intent (in) :: copt
    end subroutine light

    subroutine litmod(id,copt)
      integer, intent (in) :: id
      character (len = *), intent (in) :: copt
    end subroutine litmod

    subroutine litopt(id,x,copt)
      integer, intent (in) :: id
      real, intent (in) :: x
      character (len = *), intent (in) :: copt
    end subroutine litopt
 
    subroutine litpos(id,xp,yp,zp,copt)
      integer, intent (in) :: id
      real, intent (in) :: xp,yp,zp
      character (len = *), intent (in) :: copt
    end subroutine litpos

    subroutine lncap(copt)
      character (len = *), intent (in) :: copt
    end subroutine lncap

    subroutine lnjoin(copt)
      character (len = *), intent (in) :: copt
    end subroutine lnjoin

    subroutine lnmlt(x)
      real, intent (in) :: x
    end subroutine lnmlt

    subroutine logtic(copt)
      character (len = *), intent (in) :: copt
    end subroutine logtic

    subroutine lsechk(copt)
      character (len = *), intent (in) :: copt
    end subroutine lsechk

    subroutine mapbas(copt)
      character (len = *), intent (in) :: copt
    end subroutine mapbas
 
    subroutine maplev(copt)
      character (len = *), intent (in) :: copt
    end subroutine maplev
 
    subroutine mapmod(copt)
      character (len = *), intent (in) :: copt
    end subroutine mapmod
 
    subroutine mappol(x,y)
      real, intent (in) :: x,y
    end subroutine mappol
 
    subroutine mapref(ylw,yup)
      real, intent (in) :: ylw,yup
    end subroutine mapref
 
    subroutine mapsph(xrad)
      real, intent (in) :: xrad
    end subroutine mapsph
 
    subroutine marker(i)
      integer, intent (in) :: i
    end subroutine marker
 
    subroutine matopt(x,copt)
      real, intent (in) :: x
      character (len = *), intent (in) :: copt
    end subroutine matopt

    subroutine mdfmat(i,j,x)
      integer, intent (in) :: i,j
      real, intent (in) :: x
    end subroutine mdfmat
 
    subroutine messag(cstr,nx,ny)
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: nx,ny
    end subroutine messag
 
    subroutine metafl(ct)
      character (len = *), intent (in) :: ct
    end subroutine metafl
 
    subroutine mixalf()
    end subroutine mixalf
 
    subroutine mixleg()
    end subroutine mixleg
 
    subroutine moment(xray,n,copt,xv)
      real, dimension (:), intent (in) :: xray
      integer, intent (in) :: n
      character (len = *), intent (in) :: copt
      real, intent (out) :: xv
    end subroutine moment
 
    subroutine mpaepl(i)
      integer, intent (in) :: i
    end subroutine mpaepl
 
    subroutine mplang(x)
      real, intent (in) :: x
    end subroutine mplang
 
    subroutine mplclr(i,j)
      integer, intent (in) :: i,j
    end subroutine mplclr
 
    subroutine mplpos(i,j)
      integer, intent (in) :: i,j
    end subroutine mplpos
 
    subroutine mplsiz(i)
      integer, intent (in) :: i
    end subroutine mplsiz
 
    subroutine msgbox(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine msgbox
 
    subroutine mshclr(ic)
      integer, intent (in) :: ic
    end subroutine mshclr

    subroutine mylab(cstr,i,cax)
      character (len = *), intent (in) :: cstr,cax
      integer, intent (in) :: i
    end subroutine mylab
 
    subroutine myline(nray,n)
      integer, dimension (:), intent (in) :: nray
      integer, intent (in) :: n
    end subroutine myline
 
    subroutine mypat(iang,itype,idens,icross)
      integer, intent (in) :: iang,itype,idens,icross
    end subroutine mypat
 
    subroutine mypie(iseg,xdat,xper,nrad,noff,ang,nvbox,idrw,iann)
      integer, intent (in out) :: iseg,nrad,noff,nvbox,idrw,iann
      real, intent (in out)    :: xdat,xper,ang
    end subroutine mypie
 
    subroutine myvlt(xr,xg,xb,n)
      real, dimension (:), intent (in) :: xr,xg,xb
      integer, intent (in) :: n
    end subroutine myvlt
 
    subroutine namdis(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine namdis
 
    subroutine name(cnam,cax)
      character (len = *), intent (in) :: cnam,cax
    end subroutine name
 
    subroutine namjus(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine namjus
 
    subroutine neglog(e)
      real, intent (in) :: e
    end subroutine neglog
 
    subroutine newmix()
    end subroutine newmix
 
    subroutine newpag()
    end subroutine newpag
 
    function nlmess(cstr) result(iret)
      character (len = *), intent (in) :: cstr
      integer :: iret
    end function nlmess
 
    function nlnumb(x,ndez) result (iret)
      real, intent (in) :: x
      integer, intent (in) :: ndez
      integer :: iret
    end function nlnumb
 
    subroutine noarln()
    end subroutine noarln
 
    subroutine nobar()
    end subroutine nobar
 
    subroutine nobgd()
    end subroutine nobgd
 
    subroutine nochek()
    end subroutine nochek
 
    subroutine noclip()
    end subroutine noclip
 
    subroutine nofill()
    end subroutine nofill
 
    subroutine nograf()
    end subroutine nograf
 
    subroutine nohide()
    end subroutine nohide
 
    subroutine noline(cax)
      character (len = *), intent (in) :: cax
    end subroutine noline
 
    subroutine number(x,ndez,nx,ny)
      real, intent (in) :: x
      integer, intent (in) :: ndez,nx,ny
    end subroutine number
 
    subroutine numfmt(ct)
      character (len = *), intent (in) :: ct
    end subroutine numfmt
 
    subroutine numode(cdec,cgrp,cpos,cspc)
      character (len = *), intent (in) :: cdec,cgrp,cpos,cspc
    end subroutine numode

    function nwkday(id,im,iy) result (iret)
      integer, intent (in) :: id,im,iy
      integer :: iret
    end function nwkday
 
    function nxlegn(cbf) result (iret)
      character (len = *), intent (in) :: cbf
      integer :: iret
    end function nxlegn
 
    function nxposn(x) result (iret)
      real, intent (in) :: x
      integer :: iret
    end function nxposn
 
    function nylegn(cbf) result (iret)
      character (len = *), intent (in) :: cbf
      integer :: iret
    end function nylegn
 
    function nyposn(y) result (iret)
      real, intent (in) :: y
      integer :: iret
    end function nyposn
 
    function nzposn(z) result (iret)
      real, intent (in) :: z
      integer :: iret
    end function nzposn
 
    subroutine openfl(cstr,nlu,irw,istat)
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: nlu,irw
      integer, intent (out) :: istat
    end subroutine openfl
 
    subroutine opnwin(id)
      integer, intent (in) :: id
    end subroutine opnwin
 
    subroutine origin(i,j)
      integer, intent (in) :: i,j
    end subroutine origin
 
    subroutine page(nxp,nyp)
      integer, intent (in) :: nxp,nyp
    end subroutine page
 
    subroutine pagera()
    end subroutine pagera
 
    subroutine pagfll(n)
      integer, intent (in) :: n
    end subroutine pagfll
 
    subroutine paghdr(c1,c2,iopt,idir)
      character (len = *), intent (in) :: c1,c2
      integer, intent (in) :: iopt,idir
    end subroutine paghdr
 
    subroutine pagmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine pagmod
 
    subroutine patcyc(i,ipat)
      integer, intent (in) :: i,ipat
    end subroutine patcyc
 
    subroutine penwid(x)
      real, intent (in) :: x
    end subroutine penwid
 
    subroutine pie(nx,ny,nr,a,b)
      integer, intent (in) :: nx,ny,nr
      real, intent (in) :: a,b
    end subroutine pie

    subroutine piebor(iclr)
      integer, intent (in) :: iclr
    end subroutine piebor

    subroutine pieclr(ic1,ic2,n)
      integer, dimension (:), intent (in) :: ic1,ic2
      integer, intent (in) :: n
    end subroutine pieclr
 
    subroutine pieexp()
    end subroutine pieexp
 
    subroutine piegrf(cstr,nlin,xray,n)
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: nlin,n
      real, dimension (:), intent (in) :: xray
    end subroutine piegrf
 
    subroutine pielab(cdat,cstr)
      character(len = *), intent (in) :: cdat,cstr
    end subroutine pielab

    subroutine pieopt(x1,x2)
      real, intent (in) :: x1,x2
    end subroutine pieopt

    subroutine pietyp(ctyp)
      character (len = *), intent (in) :: ctyp
    end subroutine pietyp
 
    subroutine pievec(ivec,copt)
      integer, intent (in) :: ivec
      character (len = *), intent (in) :: copt
    end subroutine pievec
 
    subroutine point(nx,ny,nb,nh,ncol)
      integer, intent (in) :: nx,ny,nb,nh,ncol
    end subroutine point
 
    subroutine polcrv(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine polcrv
 
    subroutine pos2pt(x,y,xp,yp)
      real, intent (in) :: x,y
      real, intent (out) :: xp,yp
    end subroutine pos2pt
 
    subroutine pos3pt(x,y,z,xp,yp,zp)
      real, intent (in) :: x,y,z
      real, intent (out) :: xp,yp,zp
    end subroutine pos3pt
 
    subroutine posifl(nlu,nbyt,istat)
      integer, intent (in) :: nlu,nbyt
      integer, intent (out) :: istat
    end subroutine posifl
 
    subroutine projct(copt)
      character (len = *), intent (in) :: copt
    end subroutine projct
 
    subroutine psfont(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine psfont
 
    subroutine qplbar(x,n)
      real, dimension (:), intent (in) :: x
      integer, intent (in) :: n
    end subroutine qplbar

    subroutine qplclr(x,n,m)
      real, dimension (:,:), intent (in) :: x
      integer, intent (in) :: n,m
    end subroutine qplclr

    subroutine qplcon(x,n,m,nlev)
      real, dimension (:,:), intent (in) :: x
      integer, intent (in) :: n,m,nlev
    end subroutine qplcon

    subroutine qplot(x,y,n)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
    end subroutine qplot

    subroutine qplpie(x,n)
      real, dimension (:), intent (in) :: x
      integer, intent (in) :: n
    end subroutine qplpie

    subroutine qplsca(x,y,n)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
    end subroutine qplsca

    subroutine qplsur(x,n,m)
      real, dimension (:,:), intent (in) :: x
      integer, intent (in) :: n,m
    end subroutine qplsur

    subroutine rbfpng(iray,nmax,nn)
      character (len=*), intent (out), dimension (:) :: iray
      integer, intent (in) :: nmax
      integer, intent (out) :: nn
    end subroutine rbfpng

    subroutine readfl(nlu,iray,nbyt,istat)
      character (len=*), intent (out), dimension (:) :: iray
      integer, intent (in) :: nlu,nbyt
      integer, intent (out) :: istat
    end subroutine readfl
 
    subroutine recfll(nx,ny,nb,nh,ncol)
      integer, intent (in) :: nx,ny,nb,nh,ncol
    end subroutine recfll
 
    subroutine rectan(nx,ny,nb,nh)
      integer, intent (in) :: nx,ny,nb,nh
    end subroutine rectan
 
    subroutine rel3pt(x,y,z,xp,yp)
      real, intent (in) :: x,y,z
      real, intent (out) :: xp,yp
    end subroutine rel3pt
 
    subroutine resatt()
    end subroutine resatt
 
    subroutine reset(cw)
      character (len = *), intent (in) :: cw
    end subroutine reset
 
    subroutine revscr()
    end subroutine revscr
 
    subroutine rgbhsv(r,g,b,xh,xs,xv)
      real, intent (in) :: r,g,b
      real, intent (out) :: xh,xs,xv
    end subroutine rgbhsv
 
    subroutine rgtlab()
    end subroutine rgtlab
 
    subroutine rimage(cfl)
      character (len = *), intent (in) :: cfl
    end subroutine rimage
 
    subroutine rlarc(xm,ym,a,b,alpha,beta,theta)
      real, intent (in) :: xm,ym,a,b,alpha,beta,theta
    end subroutine rlarc
 
    subroutine rlarea(x,y,n)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
    end subroutine rlarea
 
    subroutine rlcirc(xm,ym,r)
      real, intent (in) :: xm,ym,r
    end subroutine rlcirc
 
    subroutine rlconn(x,y)
      real, intent (in) :: x,y
    end subroutine rlconn
 
    subroutine rlell(xm,ym,a,b)
      real, intent (in) :: xm,ym,a,b
    end subroutine rlell
 
    subroutine rline(x,y,u,v)
      real, intent (in) :: x,y,u,v
    end subroutine rline
 
    subroutine rlmess(cstr,x,y)
      character (len = *), intent (in) :: cstr
      real, intent (in) :: x,y
    end subroutine rlmess
 
    subroutine rlnumb(z,ndez,x,y)
      real, intent (in) :: z,x,y
      integer, intent (in) :: ndez
    end subroutine rlnumb
 
    subroutine rlpie(xm,ym,r,alpha,beta)
      real, intent (in) :: xm,ym,r,alpha,beta
    end subroutine rlpie
 
    subroutine rlpoin(x,y,nb,nh,ncol)
      real, intent (in) :: x,y
      integer, intent (in) :: nb,nh,ncol
    end subroutine rlpoin
 
    subroutine rlrec(x,y,xb,xh)
      real, intent (in) :: x,y,xb,xh
    end subroutine rlrec
 
    subroutine rlrnd(x,y,xb,xh,irnd)
      real, intent (in) :: x,y,xb,xh
      integer, intent (in) :: irnd
    end subroutine rlrnd
 
    subroutine rlsec(xm,ym,r1,r,beta,alpha,ncol)
      real, intent (in) :: xm,ym,r1,r,beta,alpha
      integer, intent (in) :: ncol
    end subroutine rlsec
 
    subroutine rlstrt(x,y)
      real, intent (in) :: x,y
    end subroutine rlstrt
 
    subroutine rlsymb(i,x,y)
      integer, intent (in) :: i
      real, intent (in) :: x,y
    end subroutine rlsymb
 
    subroutine rlvec(x,y,u,v,ivec)
      real, intent (in) :: x,y,u,v
      integer, intent (in) :: ivec
    end subroutine rlvec
 
    subroutine rndrec(nx,ny,nb,nh,irnd)
      integer, intent (in) :: nx,ny,nb,nh,irnd
    end subroutine rndrec
 
    subroutine rpixel(ix,iy,n)
      integer, intent (in)  :: ix,iy
      integer, intent (out) :: n
    end subroutine rpixel
 
    subroutine rpixls(iray,ix,iy,nw,nh)
      character (len=*), intent (out), dimension (:) :: iray
      integer, intent (in) :: ix,iy,nw,nh
    end subroutine rpixls

    subroutine rpng(cfl)
      character (len=*), intent (in) :: cfl
    end subroutine rpng
 
    subroutine rppm(cfl)
      character (len=*), intent (in) :: cfl
    end subroutine rppm
 
    subroutine rpxrow(iray,ix,iy,n)
      character (len=*), intent (out), dimension (:) :: iray
      integer, intent (in) :: ix,iy,n
    end subroutine rpxrow
 
    subroutine rtiff(cfl)
      character (len=*), intent (in) :: cfl
    end subroutine rtiff
 
    subroutine rvynam()
    end subroutine rvynam
 
!    subroutine scale(copt,cax)
!      character (len = *), intent (in) :: copt,cax
!    end subroutine scale
 
    subroutine sclfac(x)
      real, intent (in) :: x
    end subroutine sclfac
 
    subroutine sclmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine sclmod
 
    subroutine scmplx()
    end subroutine scmplx
 
    subroutine scrmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine scrmod
 
    subroutine sector(nx,ny,nr1,nr2,alpha,beta,ncol)
      integer, intent (in) :: nx,ny,nr1,nr2,ncol
      real, intent (in) :: alpha,beta
    end subroutine sector
 
    subroutine selwin(id)
      integer, intent (in) :: id
    end subroutine selwin
 
    subroutine sendbf()
    end subroutine sendbf
 
    subroutine sendok()
    end subroutine sendok

    subroutine sendmb()
    end subroutine sendmb
 
    subroutine serif()
    end subroutine serif
 
    subroutine setbas(f)
      real, intent (in) :: f
    end subroutine setbas
 
    subroutine setclr(n)
      integer, intent (in) :: n
    end subroutine setclr
 
    subroutine setexp(f)
      real, intent (in) :: f
    end subroutine setexp
 
    subroutine setfil(ct)
      character (len = *), intent (in) :: ct
    end subroutine setfil
 
    subroutine setgrf(c1,c2,c3,c4)
      character (len = *), intent (in) :: c1,c2,c3,c4
    end subroutine setgrf
 
    subroutine setind(i,xr,xg,xb)
      integer, intent (in) :: i
      real, intent (in) :: xr,xg,xb
    end subroutine setind
 
    subroutine setmix(c,cstr)
      character (len = *), intent (in) :: c,cstr
    end subroutine setmix
 
    subroutine setpag(ct)
      character (len = *), intent (in) :: ct
    end subroutine setpag
 
    subroutine setres(i,j)
      integer, intent (in) :: i,j
    end subroutine setres
 
    subroutine setrgb(xr,xg,xb)
      real, intent (in) :: xr,xg,xb
    end subroutine setrgb
 
    subroutine setscl(xray,n,cstr)
      real, dimension (:), intent (in) :: xray
      integer, intent (in) :: n
      character (len = *), intent (in) :: cstr
    end subroutine setscl
 
    subroutine setvlt(ctab)
      character (len = *), intent (in) :: ctab
    end subroutine setvlt
 
    subroutine setxid(i,copt)
      integer, intent (in) :: i
      character (len = *), intent (in) :: copt
    end subroutine setxid
 
    subroutine shdcha()
    end subroutine shdcha
 
    subroutine shdcrv(x1,y1,n1,x2,y2,n2)
      real, dimension (:), intent (in) :: x1,y1,x2,y2
      integer, intent (in) :: n1,n2
    end subroutine shdcrv
 
    subroutine shdeur(inat,ishd,iclr,n)
      integer, dimension (:), intent (in) :: inat,ishd,iclr
      integer, intent (in) :: n
    end subroutine shdeur
 
    subroutine shdmap(cmap)
      character (len = *), intent (in) :: cmap
    end subroutine shdmap
 
    subroutine shdmod(copt,ctype)
      character (len = *), intent (in) :: copt,ctype
    end subroutine shdmod
 
    subroutine shdpat(i)
      integer, intent (in) :: i
    end subroutine shdpat
 
    subroutine shield(cblnk,cmode)
      character (len = *), intent (in) :: cblnk,cmode
    end subroutine shield
 
    subroutine shlcir(nx,ny,nr)
      integer, intent (in) :: nx,ny,nr
    end subroutine shlcir
 
    subroutine shldel(id)
      integer, intent (in) :: id
    end subroutine shldel
 
    subroutine shlell(nx,ny,na,nb,ang)
      integer, intent (in) :: nx,ny,na,nb
      real, intent (in) :: ang
    end subroutine shlell
 
    subroutine shlind(id)
      integer, intent (out) :: id
    end subroutine shlind
 
    subroutine shlpie(nx,ny,nr,alph,beta)
      integer, intent (in) :: nx,ny,nr
      real, intent (in) :: alph,beta
    end subroutine shlpie
 
    subroutine shlpol(nxray,nyray,n)
      integer, dimension (:), intent (in) :: nxray,nyray
      integer, intent (in) :: n
    end subroutine shlpol
 
    subroutine shlrct(nx,ny,nw,nh,ang)
      integer, intent (in) :: nx,ny,nw,nh
      real,    intent (in) :: ang
    end subroutine shlrct
 
    subroutine shlrec(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine shlrec
 
    subroutine shlres(nn)
      integer, intent (in) :: nn
    end subroutine shlres
 
    subroutine shlsur()
    end subroutine shlsur
 
    subroutine shlvis(id,cvis)
      integer, intent (in) :: id
      character (len = *), intent (in) :: cvis
    end subroutine shlvis
 
    subroutine simplx()
    end subroutine simplx
 
    subroutine skipfl(nlu,nbyt,istat)
      integer, intent (in) :: nlu,nbyt
      integer, intent (out) :: istat
    end subroutine skipfl
 
    subroutine smxalf(calph,ca,cb,n)
      character (len = *), intent (in) :: calph,ca,cb
      integer, intent (in) :: n
    end subroutine smxalf
 
    subroutine solid()
    end subroutine solid
 
    subroutine sortr1(x,n,copt)
      real, dimension (:), intent (in out) :: x
      integer, intent (in) :: n
      character (len = *), intent (in) :: copt
    end subroutine sortr1
 
    subroutine sortr2(x,y,n,copt)
      integer, intent (in) :: n
      real, dimension (:), intent (in out) :: x,y
      character (len = *), intent (in) :: copt
    end subroutine sortr2
 
    subroutine sphe3d(xm,ym,zm,r,nsk1,nsk2)
      real, intent (in) :: xm,ym,zm,r
      integer, intent (in) :: nsk1,nsk2
    end subroutine sphe3d
 
    subroutine spline(x,y,n,xray,yray,ndat)
      real, dimension (:),intent (in) :: x,y
      integer, intent (in) :: n
      real, dimension (:),intent (out) :: xray,yray
      integer, intent (out) :: ndat
    end subroutine spline
 
    subroutine splmod(k,n)
      integer, intent (in) :: k,n
    end subroutine splmod
 
    subroutine strt3d(x,y,z)
      real, intent (in) :: x,y,z
    end subroutine strt3d
 
    subroutine strtpt(x,y)
      real, intent (in) :: x,y
    end subroutine strtpt
 
    subroutine surclr(itop,ibot)
      integer, intent (in) :: itop,ibot
    end subroutine surclr
 
    subroutine surfce(xray,ixdim,yray,iydim,zmat)
      real, dimension (:), intent (in) :: xray,yray
      integer, intent (in) :: ixdim,iydim
      real, dimension (:,:), intent (in) :: zmat
    end subroutine surfce
 
!    subroutine surfcp(zfun,a1,a2,astp,b1,b2,bstp)
!      interface
!         function zfun(x,y,iopt)
!           real, intent (in) :: x,y
!           integer, intent (in) :: iopt
!           real :: zfun
!         end function zfun
!      end interface
!      real, intent (in) :: a1,a2,astp,b1,b2,bstp
!    end subroutine surfcp
 
!    subroutine surfun(zfun,ixpts,xdel,iypts,ydel)
!      interface
!         function zfun(x,y)
!           real, intent (in) :: x,y
!           real :: zfun
!         end function zfun
!      end interface
!      integer, intent (in) :: ixpts,iypts
!      real, intent (in) :: xdel,ydel
!    end subroutine surfun
 
    subroutine suriso(xray,nx,yray,ny,zray,nz,wmat,wlev)
      real, dimension (:), intent (in) :: xray,yray,zray
      integer, intent (in) :: nx,ny,nz
      real, dimension (:,:,:), intent (in) :: wmat
      real, intent (in) :: wlev
    end subroutine suriso

    subroutine surmat(zmat,ixdim,iydim,ixp,iyp)
      integer, intent (in) :: ixdim,iydim,ixp,iyp
      real, dimension (:,:), intent (in) :: zmat
    end subroutine surmat
 
    subroutine surmsh(copt)
      character (len = *), intent (in) :: copt
    end subroutine surmsh
 
    subroutine suropt(copt)
      character (len = *), intent (in) :: copt
    end subroutine suropt

    subroutine surshd(xray,ixdim,yray,iydim,zmat)
      real, dimension (:), intent (in) :: xray,yray
      integer, intent (in) :: ixdim,iydim
      real, dimension (:,:), intent (in) :: zmat
    end subroutine surshd
 
    subroutine sursze(ax,ex,ay,ey)
      real, intent (in) :: ax,ex,ay,ey
    end subroutine sursze
 
    subroutine survis(copt)
      character (len = *), intent (in) :: copt
    end subroutine survis
 
    subroutine swapi2(iray,n)
!      integer (kind=selected_int_kind(4)), dimension (:), &
!              intent (in out) :: iray
      integer, dimension (:), intent (in out) :: iray
      integer, intent (in) :: n
    end subroutine swapi2
 
    subroutine swapi4(iray,n)
      integer, dimension (:), intent (in out) :: iray
      integer, intent (in) :: n
    end subroutine swapi4
 
    subroutine swgatt (id,cval,copt)
      integer, intent (in) :: id
      character (len=*), intent (in) :: cval,copt
    end subroutine swgatt

    subroutine swgbox(id,ival)
      integer, intent (in) :: id,ival
    end subroutine swgbox
 
    subroutine swgbut(id,ival)
      integer, intent (in) :: id,ival
    end subroutine swgbut
 
!    subroutine swgcb (id, callbk, iray)
!      integer, intent (in) :: id
!      integer, dimension (:), intent (in) :: iray
! 
!      interface
!         subroutine callbk (id,iray)
!           integer, intent (in) :: id
!           integer, dimension (:), intent (in) :: iray
!         end subroutine callbk
!      end interface
!    end subroutine swgcb
 
    subroutine swgdrw(x)
      real, intent (in) :: x
    end subroutine swgdrw

    subroutine swgfil(id,cstr)
      integer, intent (in) :: id
      character (len=*), intent (in) :: cstr
    end subroutine swgfil
 
    subroutine swgfnt(cstr)
      character (len=*), intent (in) :: cstr
    end subroutine swgfnt
 
    subroutine swghlp(cstr)
      character (len=*), intent (in) :: cstr
    end subroutine swghlp
 
    subroutine swgjus (ctype,cwidg)
      character (len=*), intent (in) :: ctype,cwidg
    end subroutine swgjus
 
    subroutine swglis(id,ival)
      integer, intent (in) :: id,ival
    end subroutine swglis
 
    subroutine swgmix(c,cstr)
      character (len=*), intent (in) :: c,cstr
    end subroutine swgmix
 
    subroutine swgmod(cmod)
      character (len=*), intent (in) :: cmod
    end subroutine swgmod
 
    subroutine swgmrg(ival,cstr)
      integer, intent (in) :: ival
      character (len=*), intent (in) :: cstr
    end subroutine swgmrg
 
    subroutine swgoff(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine swgoff

    subroutine swgopt (cval,copt)
      character (len=*), intent (in) :: cval,copt
    end subroutine swgopt
 
    subroutine swgpop (copt)
      character (len=*), intent (in) :: copt
    end subroutine swgpop
 
    subroutine swgpos(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine swgpos
 
    subroutine swgscl(id,xval)
      integer, intent (in) :: id
      real, intent (in) :: xval
    end subroutine swgscl
 
    subroutine swgsiz(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine swgsiz

    subroutine swgspc(x, y)
      real, intent (in) :: x,y
    end subroutine swgspc
 
    subroutine swgtit(cstr)
      character (len=*), intent (in) :: cstr
    end subroutine swgtit
 
    subroutine swgtxt(id,cstr)
      integer, intent (in) :: id
      character (len=*), intent (in) :: cstr
    end subroutine swgtxt
 
    subroutine swgtyp (ctype,cwidg)
      character (len=*), intent (in) :: ctype,cwidg
    end subroutine swgtyp
 
    subroutine swgwin(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine swgwin
 
    subroutine swgwth (nwth)
      integer, intent (in) :: nwth
    end subroutine swgwth
 
    subroutine symbol(i,nx,ny)
      integer, intent (in) :: i,nx,ny
    end subroutine symbol
 
    subroutine symfil(cdv,cst)
      character (len=*), intent (in) :: cdv,cst
    end subroutine symfil
 
    subroutine symrot(xrot)
      real, intent (in) :: xrot
    end subroutine symrot
 
    subroutine tellfl(nlu,nbyt)
      integer, intent (in) :: nlu
      integer, intent (out) :: nbyt
    end subroutine tellfl

    subroutine texmod(copt)
      character (len = *), intent (in) :: copt
    end subroutine texmod
 
    subroutine texopt(copt,ctype)
      character (len = *), intent (in) :: copt,ctype
    end subroutine texopt
 
    subroutine thkcrv(i)
      integer, intent (in) :: i
    end subroutine thkcrv
 
    subroutine ticks(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine ticks
 
    subroutine ticlen(i1,i2)
      integer, intent (in) :: i1,i2
    end subroutine ticlen
 
    subroutine ticmod(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine ticmod

    subroutine ticpos(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine ticpos
 
    subroutine tiforg(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine tiforg
 
    subroutine tifwin(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine tifwin
 
    subroutine timopt()
    end subroutine timopt
 
    subroutine titjus(copt)
      character (len = *), intent (in) :: copt
    end subroutine titjus
 
    subroutine title()
    end subroutine title
 
    subroutine titlin(cstr,j)
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: j
    end subroutine titlin
 
    subroutine titpos(copt)
      character (len = *), intent (in) :: copt
    end subroutine titpos
 
    subroutine trfco1(xray,n,cfrom,cto)
      real, dimension (:), intent (in out) :: xray
      integer, intent (in) :: n
      character (len = *), intent(in) :: cfrom, cto
    end subroutine trfco1
 
    subroutine trfco2(xray,yray,n,cfrom,cto)
      real, dimension (:), intent (in out) :: xray,yray
      integer, intent (in) :: n
      character (len = *), intent(in) :: cfrom, cto
    end subroutine trfco2
 
    subroutine trfco3(xray,yray,zray,n,cfrom,cto)
      real, dimension (:), intent (in out) :: xray,yray,zray
      integer, intent (in) :: n
      character (len = *), intent(in) :: cfrom, cto
    end subroutine trfco3
 
    subroutine trfdat(ndays,id,im,iy)
      integer, intent (in) :: ndays
      integer, intent (out) :: id,im,iy
    end subroutine trfdat

    subroutine trfrel(x,y,n)
      real, dimension (:), intent (in out) :: x,y
      integer, intent (in) :: n
    end subroutine trfrel
 
    subroutine trfres()
    end subroutine trfres
 
    subroutine trfrot(xang,nx,ny)
      real, intent (in) :: xang
      integer, intent (in) :: nx,ny
    end subroutine trfrot
 
    subroutine trfscl(xscl,yscl)
      real, intent (in) :: xscl,yscl
    end subroutine trfscl
 
    subroutine trfshf(nxshf,nyshf)
      integer, intent (in) :: nxshf,nyshf
    end subroutine trfshf
 
    subroutine triplx()
    end subroutine triplx
 
    function trmlen(cstr) result (xret)
      character (len = *), intent (in) :: cstr
      real :: xret
    end function trmlen
 
    subroutine txtjus(copt)
      character (len = *), intent (in) :: copt
    end subroutine txtjus
  end interface
end module dislin_mod2
