!/****************************************************************/
!/**                       DISLIN.F90                           **/
!/**                                                            **/
!/** Module file for DISLIN Fortran 90.                         **/
!/**                                                            **/
!/** Date     : 15.02.2000                                      **/
!/** Routines :      u-z                                        **/
!/** Version  :  7.3                                            **/
!/****************************************************************/
 
module dislin_mod3

public :: unit  , upstr , usrpie, vang3d
public :: vclp3d, vector, vectr3, vfoc3d, view3d, vkxbar, vkybar, vkytit
public :: vup3d , wgapp , wgbas , wgbox , wgbut , wgcmd , wgfil , wgfin 
public :: wgini , wglab , wglis , wgltxt, wgok  , wgpbut, wgpop , wgquit
public :: wgscl , wgtxt , widbar, wimage, winapp, window, winfnt, winid 
public :: winmod, winsiz, wintit, world , wpixel, wpixls, wpxrow, writfl
public :: wtiff , x11mod, x2dpos, x3dabs, x3dpos, x3drel, xaxgit, xaxis 
public :: xaxlg , xaxmap, xcross, xdraw , xinvrs, xmove , xposn , y2dpos
public :: y3dabs, y3dpos, y3drel, yaxgit, yaxis , yaxlg , yaxmap, ycross
public :: yinvrs, yposn , z3dpos, zaxis , zaxlg , zbffin, zbfini, zbflin
public :: zbftri, zscale, wgdlis, wgdraw

  interface
    subroutine unit(i)
      integer, intent (in) :: i
    end subroutine unit
 
    subroutine upstr(cstr)
      character (len = *), intent (in out) :: cstr
    end subroutine upstr
 
    subroutine usrpie(iseg,xdat,xper,nrad,noff,ang,nvbox,idrw,iann)
      integer, intent (in out) :: iseg,nrad,noff,nvbox,idrw,iann
      real,    intent (in out) :: xdat,xper,ang
    end subroutine usrpie
 
    subroutine vang3d(a)
      real, intent (in) :: a
    end subroutine vang3d
 
    subroutine vclp3d(x1,x2)
      real, intent (in) :: x1,x2
    end subroutine vclp3d
 
    subroutine vector(ix1,iy1,ix2,iy2,ivec)
      integer, intent (in) :: ix1,iy1,ix2,iy2,ivec
    end subroutine vector
 
    subroutine vectr3(x1,y1,z1,x2,y2,z2,ivec)
      real, intent (in) :: x1,y1,z1,x2,y2,z2
      integer, intent (in) :: ivec
    end subroutine vectr3
 
    subroutine vfoc3d(x,y,z,cview)
      real, intent (in) :: x,y,z
      character (len = *), intent (in) :: cview
    end subroutine vfoc3d
 
    subroutine view3d(x,y,z,cview)
      real, intent (in) :: x,y,z
      character (len = *), intent (in) :: cview
    end subroutine view3d
 
    subroutine vkxbar(i)
      integer, intent (in) :: i
    end subroutine vkxbar
 
    subroutine vkybar(i)
      integer, intent (in) :: i
    end subroutine vkybar
 
    subroutine vkytit(i)
      integer, intent (in) :: i
    end subroutine vkytit
 
    subroutine vup3d(a)
      real, intent (in) :: a
    end subroutine vup3d
 
    subroutine wgapp(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgapp
 
    subroutine wgbas(ip,copt,id)
      character (len = *), intent (in) :: copt
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgbas
 
    subroutine wgbox(ip,cstr,isel,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,isel
      integer, intent (out) :: id
    end subroutine wgbox
 
    subroutine wgbut(ip,cstr,ival,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,ival
      integer, intent (out) :: id
    end subroutine wgbut
 
    subroutine wgcmd(ip,clab,cstr,id)
      character (len = *), intent (in) :: clab,cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgcmd

    subroutine wgdlis(ip,cstr,isel,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,isel
      integer, intent (out) :: id
    end subroutine wgdlis

    subroutine wgdraw(ip,id)
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgdraw
 
    subroutine wgfil(ip,clab,cstr,cmask,id)
      character (len = *), intent (in) :: clab,cstr,cmask
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgfil
 
    subroutine wgfin()
    end subroutine wgfin
 
    subroutine wgini(ctype,id)
      character (len = *), intent (in) :: ctype
      integer, intent (out) :: id
    end subroutine wgini
 
    subroutine wglab(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wglab
 
    subroutine wglis(ip,cstr,isel,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,isel
      integer, intent (out) :: id
    end subroutine wglis
 
    subroutine wgltxt(ip,clab,cstr,iper,id)
      character (len = *), intent (in) :: clab,cstr
      integer, intent (in)  :: ip,iper
      integer, intent (out) :: id
    end subroutine wgltxt
 
    subroutine wgok(ip,id)
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgok
 
    subroutine wgpbut(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgpbut
 
    subroutine wgpop(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgpop
 
    subroutine wgquit(ip,id)
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgquit
 
    subroutine wgscl(ip,cstr,x1,x2,xval,ndez,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,ndez
      real, intent (in)     :: x1,x2,xval
      integer, intent (out) :: id
    end subroutine wgscl
 
    subroutine wgtxt(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgtxt
 
    subroutine widbar(i)
      integer, intent (in) :: i
    end subroutine widbar
 
    subroutine wimage(cfl)
      character (len = *), intent (in) :: cfl
    end subroutine wimage
 
    subroutine winapp(copt)
      character (len = *), intent (in) :: copt
    end subroutine winapp
 
    subroutine window(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine window
 
    subroutine winfnt(cfnt)
      character (len = *), intent (in) :: cfnt
    end subroutine winfnt
 
    subroutine winid(id)
      integer, intent (out) :: id
    end subroutine winid
 
    subroutine winmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine winmod
 
    subroutine winsiz(nw,nh)
      integer, intent (in) :: nw,nh
    end subroutine winsiz
 
    subroutine wintit(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine wintit
 
    subroutine world()
    end subroutine world
 
    subroutine wpixel(ix,iy,n)
      integer, intent (in) :: ix,iy,n
    end subroutine wpixel
 
    subroutine wpixls(iray,ix,iy,nw,nh)
      character (len=*), intent (in), dimension (:) :: iray
      integer, intent (in) :: ix,iy,nw,nh
    end subroutine wpixls
 
    subroutine wpxrow(iray,ix,iy,n)
      character (len=*), intent (in), dimension (:) :: iray
      integer, intent (in) :: ix,iy,n
    end subroutine wpxrow
 
    subroutine writfl(nlu,iray,nbyt,istat)
      character (len=*), intent (in), dimension (:) :: iray
      integer, intent (in) :: nlu,nbyt
      integer, intent (out) :: istat
    end subroutine writfl
 
    subroutine wtiff(cfl)
      character (len=*), intent (in) :: cfl
    end subroutine wtiff
 
    subroutine x11mod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine x11mod
 
    function x2dpos(x,y) result (xret)
      real, intent (in) :: x,y
      real :: xret
    end function x2dpos
 
    function x3dabs(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function x3dabs
 
    function x3dpos(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function x3dpos
 
    function x3drel(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function x3drel
 
    subroutine xaxgit()
    end subroutine xaxgit
 
    subroutine xaxis(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine xaxis
 
    subroutine xaxlg(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine xaxlg
 
    subroutine xaxmap(a,b,o,step,cstr,it,iy)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: it,iy
      character (len = *), intent (in) :: cstr
    end subroutine xaxmap
 
    subroutine xcross()
    end subroutine xcross
 
    subroutine xdraw(xx,yy)
      real, intent (in) :: xx,yy
    end subroutine xdraw
 
    function xinvrs(i) result (xret)
      integer, intent (in) :: i
      real :: xret
    end function xinvrs
 
    subroutine xmove(x,y)
      real, intent (in) :: x,y
    end subroutine xmove
 
    function xposn(x) result (xret)
      real, intent (in) :: x
      real :: xret
    end function xposn
 
    function y2dpos(x,y) result (xret)
      real, intent (in) :: x,y
      real :: xret
    end function y2dpos
 
    function y3dabs(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function y3dabs
 
    function y3dpos(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function y3dpos
 
    function y3drel(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function y3drel
 
    subroutine yaxgit()
    end subroutine yaxgit
 
    subroutine yaxis(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine yaxis
 
    subroutine yaxlg(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine yaxlg
 
    subroutine yaxmap(a,b,o,step,cstr,it,ix)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: it,ix
      character (len = *), intent (in) :: cstr
    end subroutine yaxmap
 
    subroutine ycross()
    end subroutine ycross
 
    function yinvrs(i) result (xret)
      integer, intent (in) :: i
      real :: xret
    end function yinvrs
 
    function yposn(y) result (xret)
      real, intent (in) :: y
      real :: xret
    end function yposn
 
    function z3dpos(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function z3dpos
 
    subroutine zaxis(a,b,o,step,il,cstr,it,idir,ix,iy)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: il,it,idir,ix,iy
      character (len = *), intent (in) :: cstr
    end subroutine zaxis
 
    subroutine zaxlg(a,b,o,step,il,cstr,it,idir,ix,iy)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: il,it,idir,ix,iy
      character (len = *), intent (in) :: cstr
    end subroutine zaxlg
 
    subroutine zbffin()
    end subroutine zbffin
 
    subroutine zbfini(iret)
      integer, intent (out) :: iret
    end subroutine zbfini
 
    subroutine zbflin(x1,y1,z1,x2,y2,z2)
      real, intent (in) :: x1,y1,z1,x2,y2,z2
    end subroutine zbflin
 
    subroutine zbftri(x,y,z,ic)
      real, dimension (3), intent (in) :: x,y,z
      integer, dimension (3), intent (in) :: ic
    end subroutine zbftri
 
    subroutine zscale(a,e)
      real, intent (in) :: a,e
    end subroutine zscale
  end interface
end module dislin_mod3
 
