program exa_areaf
    use dislin
    implicit none
 
    character (len=60), parameter :: ctit = "Shading Patterns (AREAF)"
    character (len=8)  :: cdev
    character (len=2)  :: cstr
    integer, dimension (4) :: ixp,iyp 
    integer, dimension (4), parameter :: ix = (/0,300,300,0/), &
                                         iy = (/0,0,400,400/)
    integer :: nl,nx,ny,nx0,ny0,i,j,ii,iclr,k

    nx0=335
    ny0=350

    write (unit=6,fmt="(a)",advance="no") "Device (XWIN, CONS, GKSL, PSCL): "
    read (unit=5,fmt="(a)") cdev
    call metafl(cdev)

    call disini()
    call setvlt("small")
    call pagera()
    call complx()
 
    call height(50)
    nl=nlmess(ctit)
    nx=(2970-nl)/2
    call messag(ctit,nx,200)
 
    do i=1,3
      ny=ny0+(i-1)*600
      do j=1,6
        iclr=(i-1)*6+j-1
        iclr=modulo(iclr,8)
        if(iclr == 0) then
          iclr=8
        end if
        call setclr(iclr)
        nx=nx0+(j-1)*400
        ii=(i-1)*6+j-1
        call shdpat(ii)
        write(unit=cstr,fmt="(i2)") ii
 
        do k=1,4
          ixp(k)=ix(k)+nx
          iyp(k)=iy(k)+ny
        end do
        call areaf(ixp,iyp,4)
 
        nl=nlmess(cstr)
        nx=nx+(300-nl)/2
        call messag(cstr,nx,ny+460)
      end do
    end do
 
    call disfin()
end program exa_areaf
